﻿using UnityEngine;
using System.IO;
using System.Collections.Generic;
using System;

public class EasyDeposit : Mod
{
    static public JsonModInfo info;
    static public KeyCode key;
    static public string APIKey;
    static string configPath = Path.Combine(SaveAndLoad.WorldPath, "EasyDeposit");
    bool Pdown = false;
    public void Start()
    {
        info = modlistEntry.jsonmodinfo;
        try
        {
            byte[] data = File.ReadAllBytes(configPath);
            key = (KeyCode)(data[0] * 256 + data[1]);
        }
        catch
        {
            key = KeyCode.Z;
        }
        Log("Mod has been loaded!");
    }

    public void Update()
    {
        bool down = (ExtraSettingsAPI_Loaded && MyInput.GetButton(APIKey)) || Input.GetKey(key);
        if (CanvasHelper.ActiveMenu == MenuType.None && down && !Pdown)
        {
            Log(depositAllItems());
        }
        Pdown = down;
    }

    public void OnModUnload()
    {
        Log("Mod has been unloaded!");
    }

    public static void Log(object message)
    {
        Debug.Log("[" + info.name + "]: " + message.ToString());
    }

    [ConsoleCommand(name: "fillNearbyChests", docs: "Deposits items from inventory to nearby storages")]
    public static string MyCommand(string[] args)
    {
        return depositAllItems();
    }

    [ConsoleCommand(name: "depositKey", docs: "Gets or sets the key to be used for depositing items")]
    public static string MyCommand2(string[] args)
    {
        if (args.Length == 0)
            return key.ToString();
        if (args.Length > 1)
            return "Too many arguments";
        try
        {
            key = (KeyCode)Enum.Parse(typeof(KeyCode), args[0], true);
            if (ExtraSettingsAPI_Loaded)
                ((EasyDeposit)modInstance).ExtraSettingsAPI_SetKeybindMain("Deposit Key", key);
            try
            {
                File.WriteAllBytes(configPath, new byte[] { (byte)((int)key / 256), (byte)((int)key % 256) });
            } catch
            {
                Log("Failed to save settings");
            }
            return "Key changed";
        } catch
        {
            return "Invalid key";
        }
    }

    public static string depositAllItems()
    {
        Network_Player player = RAPI.GetLocalPlayer();
        if (player == null)
            return "Must be used in world";
        List<Slot> playerItems = player.Inventory.allSlots;
        List<Slot> items = new List<Slot>();
        foreach (Slot slot in playerItems)
            if ((int)slot.slotType % 2 == 1)
            {
                items.Add(slot);
            }
        foreach (Storage_Small storage in StorageManager.allStorages)
        {
            Inventory container = storage.GetInventoryReference();
            if (storage.IsOpen || container == null || !Helper.LocalPlayerIsWithinDistance(storage.transform.position, player.StorageManager.maxDistanceToStorage))
                continue;
            foreach (Slot slot in playerItems)
                if (!slot.IsEmpty && container.GetItemCount(slot.GetItemBase()) > 0 && (int)slot.slotType % 2 == 1)
                {
                    container.AddItem(slot.itemInstance, false);
                    if (slot.itemInstance.Amount == 0)
                        slot.SetItem(null);
                }
        }
        return "Items deposited";
    }

    public void ExtraSettingsAPI_Load()
    {
        APIKey = ExtraSettingsAPI_GetKeybind("Deposit Key");
    }

    public void ExtraSettingsAPI_SettingsOpen()
    {

    }

    public void ExtraSettingsAPI_SettingsClose()
    {
        key = MyInput.Keybinds[APIKey].MainKey;
    }


    static HarmonyLib.Traverse ExtraSettingsAPI_Traverse;
    static bool ExtraSettingsAPI_Loaded = false;
    public string ExtraSettingsAPI_GetKeybind(string SettingName)
    {
        if (ExtraSettingsAPI_Loaded)
            return ExtraSettingsAPI_Traverse.Method("getKeybindName", new object[] { this, SettingName }).GetValue<string>();
        return "";
    }
    public void ExtraSettingsAPI_SetKeybindMain(string SettingName, KeyCode value)
    {
        if (ExtraSettingsAPI_Loaded)
            ExtraSettingsAPI_Traverse.Method("setKeybind_main", new object[] { this, SettingName, value }).GetValue();
    }
}